//
// DYNARE SOURCE CODE for QUEST III, the macroeconomic model of the European Commission
//
// QUEST III: An Estimated Open-Economy DSGE
// Model of the Euro Area with Fiscal and Monetary Policy
// by, Marco Ratto, Werner Roeger, Jan in t Veld,
// Economic Modelling, 2008.
//
//
//  

var  
E_BGYN       	$BGYN_t$
E_BWRY       	$BWRY_t$
E_CLCSN      	$CSN_t^k$
E_DBGYN       $deficit_t$
E_LER        	$\log(ER_t)$
E_ETA        	$\eta_t$
E_GC         	$GC_t$
E_GCL        	$GC_t^{lev}$
E_GCLC       	$GC_t^k$
E_GCNLC      	$GC_t^i$
E_GE         	$GE_t$
E_GEX        	$GEX_t$
E_GEXL       	$GEX_t^{lev}$
E_GG         	$GG_t$
E_GGL        	$GG_t^{lev}$
E_GI         	$GI_t$
E_GIG        	$GGI_t$
E_GIL        	$GI_t^{lev}$
E_GIM        	$GIM_t$
E_GIML       	$GIM_t^{lev}$
E_GK         	$GK_t$
E_GKG         $GKG_t$
E_GL         	$GL_t$
E_GSN        	$GSN_t$
E_GTAX       	$GTAX_t$
E_GTFP       	$GTFP_t$
E_GTFPUCAP   	$GTFPUCAP_t$
E_GTR        	$GTR_t$
E_GUC        	$GUC_t$
E_GUCAP      	$GUCAP_t$
E_GWRY       	$GWRY_t$
E_GY         	$GY_t$
E_GYL        	$GY_t^{lev}$// bu
E_GYPOT      	$GYPOT_t$
E_GYW        	$GY^W_t$
E_INOM       	$inom_t$
E_INOMW      	$inom_t^F$
E_LL         	$\log(L_t)$
E_LL0         	$\log(L_t)$
E_LBGYN      	$\log(BGYN_t)$
E_LCSN       	$\log(CSN_t)$
E_LCLCSN     	$\log(CSN_t^k)$
E_LCNLCSN    	$\log(CSN_t^i)$
E_LEXYN      	$\log(EXSN_t)$
E_LGSN       	$\log(GSN_t)$
E_LIGSN      	$\log(GISN_t)$
E_LIMYN      	$\log(IMSN_t)$
E_LIK        	$\log(I_t/K_{t-1})$
E_LIKG        $\log(I^G_t/K^G_{t-1})$
E_LISN       	$\log(ISN_t)$
E_LOL        	$LOL_t$
E_LPCP       	$\log(PC_t/P_t)$
E_LPMP       	$\log(PM_t/P_t)$
E_LPXP       	$\log(PX_t/P_t)$
E_LTRYN       $\log(TRSN_t)$
E_LUCYN      	$\log(UCYN^i_t)$
E_LUCLCYN    	$\log(UCYN^k_t)$
E_LYGAP      	$\log(YGAP_t)$
E_LYKPPI     	$\log(1/KSN_t)$
E_LYWR       	$\log(YWR_t)$
E_LYWY       	$\log(YWY_t)$
E_MRY        	$\log(MSN_t)$
E_PHI        	$\pi_t$
E_PHIC       	$\pi_t^C$
E_PHIPI      	$g_t^{UI}$
E_PHIM       	$\pi_t^M$
E_PHIML      	$\pi_t^{M,lev}$
E_PHIW       	$\pi_t^F$
E_PHIX       	$\pi_t^X$
E_PHIXL      	$\pi_t^{X,lev}$
E_Q          	$Q_t$
E_R          	$r_t$
E_TAXYN      	$TAXSN_t$
E_TBYN       	$NTBSN_t$
E_TRTAXYN    	$NETTRSN_t$
E_TRW      	  $TRSN_t$
E_TRYN       	$TRSN_t$
E_TW         	$t^w_t$
E_UCAP       	$ucap_t$
E_UCAP0       $ucap_t^{ss}$
E_VL         	$VL^i_t$
E_VLLC        $VL^k_t$
E_WPHI       	$\pi^W_t$
E_WRPHI      	$\pi^{WR}_t$
E_WS         	$WS_t$
E_WSW        	$WSW_t$
E_ZEPS_C     	$e_t^C$
E_ZEPS_ETA   	$e_t^{\eta}$
E_ZEPS_ETAM    	$e_t^{PM}$
E_ZEPS_ETAX  	$e_t^{PX}$
E_ZEPS_EX    	$e_t^{EX}$
E_ZEPS_G     	$e_t^{CG}$
E_ZEPS_IG    	$e_t^{IG}$
E_ZEPS_L     	$e_t^{Leis}$
E_ZEPS_M     	$e_t^{M}$
E_ZEPS_PPI  	$e_t^{UI}$
E_ZEPS_RPREME	$e_t^{B^F}$
E_ZEPS_RPREMK	$e_t^{rp}$
E_ZEPS_TR    	$e_t^{TR}$
E_ZEPS_W     	$e_t^{L}$
E_ZPHIT  	$\pi_t^{T}$
E_LCY $ $
E_LGY $ $
E_LWS $ $
;

   
    
varexo
E_EPS_C     	$\epsilon^{C^i}_t$
E_EPS_ETA   	$\epsilon^{\eta}_t$
E_EPS_ETAM    	$\epsilon^{PM}_t$
E_EPS_ETAX  	$\epsilon^{PX}_t$
E_EPS_EX    	$\epsilon^{EX}_t$
E_EPS_G     	$\epsilon^{CG}_t$
E_EPS_IG    	$\epsilon^{IG}_t$
E_EPS_INOMW 	$\epsilon^{inom^F}_t$
E_EPS_L     	$\epsilon^{Leis}_t$
E_EPS_LOL   	$\epsilon^{LOL}_t$
E_EPS_M     	$\epsilon^{M}_t$
E_EPS_PPI  	$\epsilon^{UI}_t$
E_EPS_PW    	$\epsilon^{PW}_t$
E_EPS_RPREME	$\epsilon^{B^F}_t$
E_EPS_RPREMK	$\epsilon^{rp}_t$
E_EPS_TR    	$\epsilon^{TR}_t$
E_EPS_W     	$\epsilon^{L}_t$
E_EPS_Y     	$\epsilon^{UP}_t$
E_EPS_YW    	$\epsilon^{YW}_t$
;

    
  
parameters
A1E       	$\gamma_{ucap,1}$
A2E       	$\gamma_{ucap,2}$
ALPHAX     	$\alpha^X$
ALPHAE    	$\alpha$
ALPHAGE    	$\alpha^G$
BETAE     	$\beta$
BGADJ1    	$bgadj_1$
BGADJ2    	$bgadj_2$
BGTAR     	$btar$
DELTAE    	$\delta$
DELTAGE    	$\delta^G$
DGEX      	$dgex$
DGIM      	$dgim$
DGPM      	$\delta$
DGPX      	$dgpx$
DDYN      	$$
E_EX_INOMW	$\bar{inom^F}$
E_EX_R    	$$
E_EX_RW   	$$
G1E       	$t_0^{CG}$
GAMI2E    	$\gamma_I$
GAMIE     	$\gamma_K$
GAMLE     	$\gamma_L$
GAMPE     	$\gamma_P$
GAMPME     	$\gamma_{PM}$
GAMPXE    	$\gamma_{PX}$
GAMWE     	$\gamma_W$
GP0       	$\bar{\pi}$
GPCPI0    	$g^{UI}$
GPOP0     	$g^{pop}$
GPW0      	$\bar{\pi^F}$
GSLAG     	$\tau_{Lag}^{CG}$
GVECM       $\tau_{Adj}^{CG}$
GFLAG       $$
GLAGFLAG    $$
IGLAGFLAG   $$
IGFLAG      $$
TRFLAG      $$
TWFLAG      $$
GEXOFLAG    $$
IGEXOFLAG   $$
TREXOFLAG   $$
GAMIFLAG    $$
SLCFLAG     $$
SIMFLAG     $$
GSN       	$\bar{gsn}$
GTFP0     	$\bar{g^U}$
GY0       	$\bar{GY}$
GYW0      	$\bar{GY^W}$
HABE      	$h^C$
HABLE     	$h^L$
IGSLAG    	$\tau_{Lag}^{IG}$
IGVECM      $\tau_{Adj}^{IG}$
ILAGE     	$\tau_{Lag}^{INOM}$
INFLAGE   	$\rho^{\pi^T}$
IG1E      	$\tau_0^{IG}$
IGSN      	$\bar{gisn}$
ISN       	$\bar{isn}$
KAPPAE    	$\kappa$
L0        	$\bar{L}$
LER0        $log(\bar{ER})$
LOL       	$\bar{LOL}$
LYWY0     	$(\bar{Y^W/Y})$
OMEGE     	$\omega$
RHOCE     	$\rho^{C^i}$
RHOETA    	$\rho^\eta$
RHOETAM    	$\rho^{PM}$
RHOETAX    	$\rho^{PX}$
RHOEXE    	$\rho^{EX}$
RHOGE     	$\rho^{G}$
RHOIG     	$\rho^{GI}$
RHOL0       $\rho^{L0}$
RHOLE     	$\rho^{Leis}$
RHOLOL    	$\rho^{LOL}$
RHOPPI1   	$\rho^{UI}_1$
RHOPPI2   	$\rho^{UI}_2$
RHOPPI3  	$\rho^{UI}_3$
RHOPPI4   	$\rho^{UI}_4$
RHOPCPM   	$\rho^{PCPM}$
RHOPWPX    	$\rho^{PWPX}$
RHORPE    	$\rho^{B^F}$
RHORPK    	$\rho^{rp}$
RHOUCAP0    $\rho^{ucap}$
RII       	$\rho^{inom^F}$
RIP       	$\rho^{inom^F,\pi^F}$
RIX       	$\rho^{inom^F,GY^W}$
RPI       	$\rho^{\pi^F,inom^F}$
RPP       	$\rho^{\pi^F}$
RPX       	$\rho^{\pi^F,GY^W}$
RXI       	$\rho^{GY^W,inom^F}$
RXP       	$\rho^{GY^W,\pi^F}$
RXX       	$\rho^{GY^W}$
RXY       	$\rho^{GY,GY^W}$
RPREME    	$risk$
RPREMK    	$rp$
SE        	$\omega^X$
SFPE      	$sfp$
SFPME     	$sfpm$
SFPXE     	$sfpx$
SFWE      	$sfw$
SIGC        $\sigma^c$
SIGEXE    	$\sigma^X$
SIGIME    	$\sigma$
SLC       	$slc$
SSC       	$ssc$
TAUE      	$\tau$
TP        	$t^p$
THETAE    	$\theta$
TINFE     	$t_{\pi}^{INOM}$
TR1E      	$b^U$
TRSN      	$\bar{trsn}$
RHOTR      	$\rho_{TR}$
TYE1      	$t^{INOM}_{Y,1}$
TYE2      	$t^{INOM}_{Y,2}$
TVAT      	$t^c$
TW0       	$t^w_0$
TW1       	$t^w_1$
UCAP0     	$\bar{ucap}$
WRLAG       $wrlag$
ZETE      	$\zeta$
;

// initialize (guess) estimated parameters, estimation will override these values 
A2E        =   0.001;
G1E        =   -1.28162312508807; 
GAMI2E     =   12.07;
GAMIE      =   14.37;
GAMLE      =   26.14;
GAMPE      =   22.77;
GAMPME     =   25;
GAMPXE     =   25;
GAMWE      =   12.07;
GSLAG      =   0.82445677707374; //0.88752233295211;
GVECM = -0.1901;
HABE       =   0.7982;
HABLE       =  0.4678;
IG1E     =   0.4501;
IGSLAG   = 0.8549;
IGVECM = -0.001;
ILAGE      =   0.8795;
KAPPAE     =   1.4513;
RHOCE      =   0.38;
RHOETA    =   0; 
RHOETAM     =   0.975;
RHOETAX     =   0.975;
RHOGE     =   0.85;
RHOIG   = 0.975;
RHOLE     =   0.975;
RHOL0     =   0.975;
RHOPCPM  =   0.9;
RHOPWPX = 0.9;
RHORPE     =   0.99349706705477; 
RHORPK     =   0.5; 
RHOUCAP0    =   0.975;
RPREMK     =   -9.8577e-004;
RPREME     =   0.001; 
SE         =   0.85; 
SFPE       =   0.5936;
SFPME      =   0.7;
SFPXE      =   0.4027;
SFWE       =   0.9928; 
SIGC       =  2;
SIGEXE     =  0.7;
SIGIME     =  0.83; 
SLC        =  0.5;
TINFE      =   1.2;
TR1E       =   -0.60826792863670; 
RHOTR     =   0.91; 
TYE1        =   0.1;
TYE2       =   -0.26564690418357;
WRLAG      =   0.5;


// calibrated parameters;  
ALPHAX        =   0.5; 
BETAE      =   0.996; 
ALPHAE     =   0.52; 
ALPHAGE    =   0.9;
BGADJ2      =  0.004; 
BGADJ1      =  0.001*BGADJ2; 
BGTAR      =   2.4;
DELTAE     =   0.025;
DELTAGE     =   0.0125;
DGIM = 0.00738619107021;  // log of dgim in ddd
DGEX = 0.00738619107021;
DGPM = -0.00396650612294;
DGPX = -0.00396650612294;
INFLAGE    =   0.98;
LOL        =   0; 
RHOEXE     =   0.975;
RHOLOL     =   0.99;
SSC        =   0.2;
TAUE       =   0.1000;
THETAE     =   1.6;
TP         =   0.2;
TRSN       =   0.36;
TVAT       =   0.2;
TW0        =   0.2;
TW1        =   0.8;
ZETE       =   0.4000;

// steady state parameters
A1E        =   0.0267; % this is actually a function of the steady state and estimated parameters to get UCAP0=1;
OMEGE      =   0.3; % this is actually a function of the steady state and estimated parameters to get L0=0.65;
GSN        =   0.203; 
IGSN      =    0.025; 
//ISN        =   0.17; % used only when DDYN=0, and RPREMK would be a function of ISN;
GPCPI0     =   0; 
GP0        =   0.005; 
GPW0       =   GP0;
GPOP0      =   0.00113377677398;
GY0        =   0.003; 
GTFP0      =   (ALPHAE+ALPHAGE-1)/ALPHAE*GY0-(2-ALPHAE-ALPHAGE)/ALPHAE*GPCPI0;      
GYW0       =   GY0;
UCAP0      =   1;
L0         =  0.65; 
LER0 = 0;
E_EX_R     =   1/BETAE-1; -log(BETAE);
E_EX_INOMW =  E_EX_R+GP0; 
E_EX_RW = E_EX_INOMW - GPW0;
LYWY0 = 0;


// VAR model for exogenous world variables, not jointly estimated 
RXY = -0.0001;
RII = 0.887131978334279;
RIP = 0.147455589872832;
RIX = 0.120095599681076;
RPI = 0.112067224979767;
RPP = 0.502758194258928;
RPX = 0.082535400836409;
RXI = 0.073730131176521;
RXP = -0.302655015002645;
RXX = 0.495000246553550;

// AR(4) for exogenous PPI process, nto jointly estimated 
RHOPPI1 =   0.24797097628284;
RHOPPI2 =  0.13739098460472;
RHOPPI3 =  0.10483962746747;
RHOPPI4 =  0.09282876044442;


// SWITCHES for various simulations
SIMFLAG=0; % for  ESTIMATION !!!!!: endogenize some params (A1E, OMEGE)  to get UCAP_ss=1; L_ss=L0
//SIMFLAG=1; % for SIMULATION given any parameter vector selected by the user,  included any A1E and OMEGE
DDYN = 1;
GFLAG=1;
GLAGFLAG=1;
IGLAGFLAG=1;
IGFLAG=1;
TRFLAG=1;
TWFLAG=1;
GEXOFLAG=1;
IGEXOFLAG=1;
TREXOFLAG=1;
SLCFLAG=1;
GAMIFLAG=1;



model;

exp(E_LUCYN) = exp(E_ZEPS_C)*(exp(E_LCNLCSN)*(1-HABE/(1+E_GCNLC-GY0)))^(-SIGC)*
    (1-OMEGE*exp(E_ZEPS_L)*(exp(E_LL)-HABLE*exp(E_LL(-1)))^KAPPAE)^(1-SIGC);                       //   1: EUC      

exp(E_LUCLCYN) = exp(E_LCLCSN)^(-SIGC)*
    (1-OMEGE*exp(E_ZEPS_L)*(exp(E_LL)-HABLE*exp(E_LL(-1)))^KAPPAE)^(1-SIGC);                       //   2: EUCLC      

E_VL = exp(E_ZEPS_C)*(exp(E_LCNLCSN)*(1-HABE/(1+E_GCNLC-GY0)))^(1-SIGC)
    *(1-OMEGE*exp(E_ZEPS_L)*(exp(E_LL)-HABLE*exp(E_LL(-1)))^KAPPAE)^(-SIGC)
    *KAPPAE*OMEGE*(exp(E_LL)-HABLE*exp(E_LL(-1)))^(KAPPAE-1)*exp(E_ZEPS_L);                        //   3: EVL      

E_VLLC = exp(E_LCLCSN)^(1-SIGC)
    *(1-OMEGE*exp(E_ZEPS_L)*(exp(E_LL)-HABLE*exp(E_LL(-1)))^KAPPAE)^(-SIGC)
    *KAPPAE*OMEGE*(exp(E_LL)-HABLE*exp(E_LL(-1)))^(KAPPAE-1)*exp(E_ZEPS_L);                        //   4: EVL      

1/BETAE-1 = E_GUC(1) + E_INOM - E_PHIC(1);                                                         //   5: EC       

E_LUCYN-E_LUCYN(-1) = E_GUC + SIGC*(E_GY-GY0 - E_PHIC + E_PHI);                                    //   6: ELAM     

(1+TVAT)*exp(E_LCLCSN) = (1-E_TW-SSC)*E_WS + E_TRW*E_WS - E_TAXYN;                                 //   7: CLC 

E_WS = exp(E_LL-E_LYWR);                                                                           //   8: WS

exp(E_LCSN)=SLCFLAG*SLC*exp(E_LCLCSN)+(1-SLCFLAG*SLC)*exp(E_LCNLCSN);                              //   9: EC

//(1+TVAT)*((1-SLC)*E_VL+SLC*E_VLLC )/((1-SLC)*exp(E_LUCYN)+SLC*exp(E_LUCLCYN)) = 
(1+TVAT)*(((1-SLC)*E_VL+SLC*E_VLLC )/((1-SLC)*exp(E_LUCYN)+SLC*exp(E_LUCLCYN)))^(1-WRLAG)*((1-E_TW-SSC)/(1+TVAT)*(THETAE-1)/THETAE/exp(E_LYWR(-1))/(1+E_GY-GY0))^WRLAG = 
   ((THETAE-1)/THETAE/exp(E_LYWR)*(1-E_TW-SSC)+GAMIFLAG*GAMWE/THETAE/exp(E_LYWR)*((E_WPHI-GP0-GY0)-(1-SFWE)*(E_PHI(-1)-GP0)))-
   BETAE*GAMIFLAG*GAMWE/THETAE/exp(E_LYWR)*((E_WPHI(1)-GP0-GY0)-(1-SFWE)*(E_PHI-GP0));             //  10: EW                       

(1+E_ZEPS_W)/(exp(E_LYWR)) = E_ETA*ALPHAE/exp(E_LL)*(1+E_LOL) - 1/(exp(E_LYWR))*GAMLE*(E_LL-E_LL(-1)) + 
           1/(exp(E_LYWR(+1)))*(1+E_GY(+1)-GY0)*GAMLE/(1+E_R)*(E_LL(+1)-E_LL);                     //  11: EL       

GAMIE*(exp(E_LIK)-(DELTAE +GPOP0+GY0+GPCPI0)) + GAMI2E*(E_GI-GY0-GPCPI0) 
        - GAMI2E/(1+E_INOM)*(E_GI(+1)-GY0-GPCPI0) = E_Q-1;                                         //  12: ENU      
       
E_ETA*(1-TP)*(1-ALPHAE)*(exp(E_LYKPPI)) = 
    E_Q-(1-E_R-DELTAE-RPREMK-E_ZEPS_RPREMK-E_PHIPI(+1)+GPCPI0)*E_Q(1) + 
    (1-sqrt(SIMFLAG^2))*(A1E*(E_UCAP-UCAP0)+A2E*(E_UCAP-UCAP0)^2)*(1-TP) +                                               //  13: ERK  
    (sqrt(SIMFLAG^2))*(A1E*(E_UCAP-((1-TAUE)*(1-ALPHAE)*((E_EX_R+RPREMK+DELTAE)/(1-TP)/(1-TAUE)/(1-ALPHAE))/A1E))+A2E*(E_UCAP-((1-TAUE)*(1-ALPHAE)*((E_EX_R+RPREMK+DELTAE)/(1-TP)/(1-TAUE)/(1-ALPHAE))/A1E))^2)*(1-TP);                                              //  13: ERK  

(E_ETA*(1-ALPHAE)*(exp(E_LYKPPI) ) ) = 
        (1-sqrt(SIMFLAG^2))*(A1E+2*A2E*(E_UCAP-UCAP0))*E_UCAP +                                                          //  14: EK       
        sqrt(SIMFLAG^2)*(A1E+2*A2E*(E_UCAP-((1-TAUE)*(1-ALPHAE)*((E_EX_R+RPREMK+DELTAE)/(1-TP)/(1-TAUE)/(1-ALPHAE))/A1E)))*E_UCAP;                                                         //  14: EK       

E_ETA = 1 - (TAUE+E_ZEPS_ETA) - 
     GAMIFLAG*GAMPE*(BETAE*(SFPE*E_PHI(1)+(1-SFPE)*E_PHI(-1)-GP0)- (E_PHI-GP0));                   //  15: EETA     

E_MRY = (1+E_INOM)^(-ZETE);                                                                        //  16: EM       

E_GK-(GY0+GPCPI0) = exp(E_LIK) -(DELTAE +GPOP0+GY0+GPCPI0);                                        //  17: EI       

E_GKG-(GY0+GPCPI0)= exp(E_LIKG)-(DELTAGE+GPOP0+GY0+GPCPI0);                                        //  18: EIG    

E_LISN = -E_LYKPPI+E_LIK+GY0+GPCPI0-E_GK;                                                          //  19: ISN          

E_GY = (1-ALPHAE)*(E_GK+E_GUCAP) +  ALPHAE*(E_GTFP + E_GL*(1+LOL)) + E_GKG*(1-ALPHAGE);            //  20: EY

E_R = E_INOM-E_PHI(1);                                                                             //  21: EINOM    

E_LYGAP = (1-ALPHAE)*(log(E_UCAP)-log(E_UCAP0))+ALPHAE*(E_LL-E_LL0);                               //  22: EYGAP

E_LL0 = RHOL0*E_LL0(-1) + (1-RHOL0)*E_LL;                                                          //  23: L0

E_UCAP0 = RHOUCAP0*E_UCAP0(-1) + (1-RHOUCAP0)*E_UCAP;                                              //  24: UCAP0

E_INOM = ILAGE*E_INOM(-1)+(1-ILAGE)*((1/BETAE-1) + E_ZPHIT + TINFE*(E_PHIC-E_ZPHIT) + TYE1*E_LYGAP(-1) ) 
              + TYE2*(E_LYGAP-E_LYGAP(-1)) + E_ZEPS_M;                                             //  25: ETAYLOR  

exp(E_LPCP) = (SE+(1-SE)*(exp(E_LPMP))^(1-SIGIME))^(1/(1-SIGIME));                                 //  26: EPCP      

exp(E_LPMP) = 
  (1 + E_ZEPS_ETAM + GAMIFLAG*GAMPME*( BETAE*(SFPME*E_PHIM(1)+(1-SFPME)*E_PHIM(-1)-GP0) -E_PHIM+GP0))*
   exp(E_LER)^ALPHAX;                                                                              //  27: EPX      

exp(E_LPXP) = 
  (1 + E_ZEPS_ETAX + GAMIFLAG*GAMPXE*( BETAE*(SFPXE*E_PHIX(1)+(1-SFPXE)*E_PHIX(-1)-GP0) -E_PHIX+GP0));   //  28: EPX      

1 = exp(E_LCSN)+exp(E_LISN)+exp(E_LIGSN)+exp(E_LGSN)+E_TBYN;                                       //  29: EQ  

E_TBYN = exp(E_LEXYN)-exp(E_LIMYN) + E_ZEPS_EX;                                                    //  30: TB

//exp(E_LIMYN) = (1-SE)*(exp(E_LPCP-E_LPMP))^(SIGIME-1)*(exp(E_LCSN)+exp(E_LISN)+exp(E_LIGSN)+exp(E_LGSN));  //  31: IM      

//exp(E_LEXYN) = (1-SE)*exp(E_LER*(ALPHAX*SE)-E_LPXP)^SIGEXE*exp(E_LPXP)*exp(E_LYWY)^ALPHAX;               //  32: EX      

exp(E_LIMYN) = (1-SE)*(exp(RHOPCPM*(E_LPCP(-1)-E_LPMP(-1)) + (1-RHOPCPM)*(E_LPCP-E_LPMP)))^SIGIME*
     exp(E_LPMP-E_LPCP)*(exp(E_LCSN)+exp(E_LISN)+exp(E_LIGSN)+exp(E_LGSN));                        //  31: IM      

exp(E_LEXYN) = (1-SE)*
    exp(RHOPWPX*(E_LER(-1)*(ALPHAX*SE)-E_LPXP(-1))+(1-RHOPWPX)*(E_LER*(ALPHAX*SE)-E_LPXP))^SIGEXE*
    exp(E_LPXP)*exp(E_LYWY)^ALPHAX;                                                                //  32: EX      

E_INOM = E_INOMW + E_GE(+1) - RPREME*E_BWRY + E_ZEPS_RPREME;                                       //  33: EE       

E_BWRY = (1+E_INOM-E_PHI(+1)-E_GY-GPOP0)*E_BWRY(-1) + E_TBYN;                                      //  34: ECA      

exp(E_LBGYN) = (1+E_R-E_GY-GPOP0)*exp(E_LBGYN(-1))+exp(E_LGSN) + exp(E_LIGSN) + E_TRW*exp(E_LL-E_LYWR)
     -(E_TW+SSC)*E_WS -TP*(1-E_WS) -TVAT*exp(E_LCSN)-E_TAXYN;                                     //  35: BG

E_GG-GY0 = GSLAG*(E_GG(-1)-GY0) + GFLAG*GVECM*(E_LGSN(-1)-log(GSN)) +  
    GFLAG*G1E*(E_LYGAP-E_LYGAP(-1)) + GFLAG*GEXOFLAG*E_ZEPS_G + (1-GFLAG)*(E_ZEPS_G-E_ZEPS_G(-1)); //  36: G

E_GIG-GY0-GPCPI0 = IGSLAG*(E_GIG(-1)-GY0-GPCPI0) + IGFLAG*IGVECM*(E_LIGSN(-1)-log(IGSN)) +  
    IGFLAG*IG1E*(E_LYGAP-E_LYGAP(-1)) + IGFLAG*IGEXOFLAG*E_ZEPS_IG + (1-IGFLAG)*(E_ZEPS_IG-E_ZEPS_IG(-1)); // 37: IG

E_GIG-E_GI = E_LIGSN-E_LISN-E_LIGSN(-1)+E_LISN(-1);                                                //  38: IGSN

E_TRW = TRSN + TRFLAG*(TR1E*(1-exp(E_LL)-(1-L0)))  + E_ZEPS_TR;                                    //  39: ETRS

E_TAXYN-E_TAXYN(-1) = BGADJ1*(exp(E_LBGYN(-1))-BGTAR)+BGADJ2*(exp(E_LBGYN)-exp(E_LBGYN(-1)));      //  40: TAX  

E_TW=TW0*(1+TW1*TWFLAG*E_LYGAP);                                                                   //  41: TW

E_TRYN = E_TRW*exp(E_LL-E_LYWR) ;                                                                  //  42: TRYN

E_TRTAXYN = E_TRW*exp(E_LL-E_LYWR) - E_TAXYN;                                                      //  43: TRTAXYN

E_WSW = (1-E_TW-SSC)*E_WS;                                                                         //  44: WSW

E_INOMW = (1-RII)*E_EX_INOMW + RII*E_INOMW(-1)             
        + RIP*(E_PHIW(-1)-GPW0) + RIX*(E_GYW(-1)-GYW0) + E_EPS_INOMW;                              //  45 INOMW (VAR)

E_PHIW-GPW0  = RPI*(E_INOMW(-1) - E_EX_INOMW)                
        + RPP*(E_PHIW(-1)-GPW0) + RPX*(E_GYW(-1)-GYW0) + E_EPS_PW;                                 //  46: PHIW (VAR)

E_GYW-GYW0    = RXI*(E_INOMW(-1) - E_EX_INOMW)
        + RXP*(E_PHIW(-1)-GPW0) + RXX*(E_GYW(-1)-GYW0) + RXY*(E_LYWY(-1)-LYWY0) + E_EPS_YW;        //  47: GYW (VECM)

E_LYWY-E_LYWY(-1)=E_GYW-E_GY;                                                                      //  48: YWY

// EXOGENOUS

(E_GTFP -GTFP0) = E_EPS_Y;                                                                         // 49: ETFP     

E_LOL-LOL = RHOLOL*(E_LOL(-1)-LOL)+E_EPS_LOL;                                                      // 49b: E_LOL

E_PHIPI = GPCPI0 + E_ZEPS_PPI;                                                                     // 50: PHIPI

E_ZEPS_C = RHOCE*E_ZEPS_C(-1)+E_EPS_C;                                                             // 51: E_ZEPS_C

E_ZEPS_ETA = RHOETA*E_ZEPS_ETA(-1)+E_EPS_ETA;                                                      // 52: E_ZEPS_ETA

E_ZEPS_ETAM = RHOETAM*E_ZEPS_ETAM(-1)+E_EPS_ETAM;                                                  // 53: E_ZEPS_ETAM

E_ZEPS_ETAX = RHOETAX*E_ZEPS_ETAX(-1)+E_EPS_ETAX;                                                  // 54: E_ZEPS_ETAX

E_ZEPS_EX = RHOEXE*E_ZEPS_EX(-1)+E_EPS_EX;                                                         // 55: E_ZEPS_EX

E_ZEPS_G = RHOGE*E_ZEPS_G(-1) + E_EPS_G;                                                           // 56: ZEPS_G

E_ZEPS_IG = RHOIG*E_ZEPS_IG(-1) + IGEXOFLAG*E_EPS_IG;                                              // 57: ZEPS_IG

E_ZEPS_L = RHOLE*E_ZEPS_L(-1)+E_EPS_L;                                                             // 58: E_ZEPS_L

E_ZEPS_M = E_EPS_M;                                                                                // 59: E_ZEPS_M

E_ZEPS_PPI = RHOPPI1*E_ZEPS_PPI(-1)+RHOPPI2*E_ZEPS_PPI(-2)+RHOPPI3*E_ZEPS_PPI(-3)+RHOPPI4*E_ZEPS_PPI(-4)+E_EPS_PPI;  //  60: ZEPS_PPI

E_ZEPS_RPREME = RHORPE*E_ZEPS_RPREME(-1)+E_EPS_RPREME;                                             //  61: E_ZEPS_RPREME

E_ZEPS_RPREMK = RHORPK*E_ZEPS_RPREMK(-1)+E_EPS_RPREMK;                                             //  62: E_ZEPS_RPREMK

E_ZEPS_W = E_EPS_W;                                                                                //  63: E_ZEPS_W

E_ZEPS_TR = RHOTR*E_ZEPS_TR(-1)+TREXOFLAG*E_EPS_TR;                                                //  64: ZEPS_TR

E_ZPHIT-GP0 = 0; //INFLAGE*(E_ZPHIT(-1)-GP0); // + E_EPS_INF;                                      //  65: ZPHIT

// IDENTITIES

E_GC-E_GY+E_PHIC-E_PHI = E_LCSN-E_LCSN(-1);                                                        //  66: GC          

E_GCLC-E_GY+E_PHIC-E_PHI = E_LCLCSN-E_LCLCSN(-1);                                                  //  67: GC          

E_GCNLC-E_GY+E_PHIC-E_PHI = E_LCNLCSN-E_LCNLCSN(-1);                                               //  68: GC          

E_GE + E_PHIW-E_PHI = E_LER-E_LER(-1);                                                             //  69: GE

E_GEX-E_GY+E_PHIX-E_PHI = E_LEXYN-E_LEXYN(-1);                                                     //  70: GEX 

E_GG-E_GY+E_PHIC-E_PHI = E_LGSN-E_LGSN(-1);                                                        //  71: GG          

E_GI - E_GK(-1) = E_LIK - E_LIK(-1);                                                               //  72: GI

E_GIG-E_GKG(-1) = E_LIKG-E_LIKG(-1);                                                               //  73: GIG

E_GIM-E_GY+E_PHIM-E_PHI = E_LIMYN-E_LIMYN(-1);                                                     //  74: GIM

(E_GY - E_GK + E_PHIPI) = E_LYKPPI - E_LYKPPI(-1);                                                 //  75: GK  

E_GL = E_LL - E_LL(-1);                                                                            //  76: GL

E_GTAX-E_GY-E_PHI = log(E_TAXYN)-log(E_TAXYN(-1));                                                 //  77: GTAX

E_GTFPUCAP = (1-ALPHAE)*E_GUCAP+ALPHAE*E_GTFP;                                                     //  78: E_GTFPUCAP 

E_GTR-E_GL-E_WRPHI=log(E_TRW)-log(E_TRW(-1));                                                      //  79: GTR  

E_GUCAP = log(E_UCAP)-log(E_UCAP(-1));                                                             //  80: GUCAP

E_GWRY=-E_LYWR+E_LYWR(-1);                                                                         //  81: GWRY  

E_GY - E_GYPOT = E_LYGAP-E_LYGAP(-1);                                                              //  82: GYPOT

E_BGYN = exp(E_LBGYN);                                                                             //  83: BGYN

E_DBGYN = E_BGYN-E_BGYN(-1);                                                                       //  84: DBGYN

E_CLCSN = exp(E_LCLCSN);                                                                           //  85: CLCSN

E_GSN = exp(E_LGSN);                                                                               //  86: GSN

E_LTRYN = log(E_TRYN);                                                                             //  87: log(TRYN)

E_PHIC-E_PHI = E_LPCP-E_LPCP(-1);                                                                  //  88: PHIC

E_PHIM-E_PHI = E_LPMP-E_LPMP(-1);                                                                  //  89: PHIM

E_PHIX-E_PHI = E_LPXP-E_LPXP(-1);                                                                  //  90: PHIX

-E_WPHI + E_GY + E_PHI = E_LYWR - E_LYWR(-1);                                                      //  91: YWR

E_WPHI = E_WRPHI+E_PHI;                                                                            //  92: EWPHI    

E_GYL = E_GY+GPOP0;                                                                                //  93: GYL

E_GCL = E_GC+GPOP0;                                                                                //  94: GCL

E_GIL = E_GI+GPOP0;                                                                                //  95: GIL

E_GGL = E_GG+GPOP0;                                                                                //  96: GGL

E_GEXL = E_GEX+GPOP0+DGEX;                                                                         //  97: GEXL

E_GIML = E_GIM+GPOP0+DGIM;                                                                         //  98: GIML

E_PHIML = E_PHIM + DGPM;                                                                           //  99: PHIML

E_PHIXL = E_PHIX + DGPX;                                                                           //  100: PHIXL

E_LCY = E_LCSN - E_LPCP;  

E_LGY = E_LGSN - E_LPCP;  

E_LWS = E_LL-E_LYWR;

end; 


initval;
E_GC = GY0;
end;    
ys_=quest1_SteadyState;

// set exogenous shocks NOT jointly estimated with the DSGE model
shocks;
var E_EPS_INOMW;
stderr  0.0023; 
var E_EPS_PW;
stderr  0.0029;
var E_EPS_YW;
stderr 0.0044;
var E_EPS_PPI;
stderr 0.00312216772065;
end;

steady;
check;

estimated_params;
// PARAM NAME, INITVAL, LB, UB, PRIOR_SHAPE, PRIOR_MEAN, PRIOR_P2, PRIOR_P3, PRIOR_P4, JSCALE;
// PRIOR_SHAPE: BETA_PDF, GAMMA_PDF, NORMAL_PDF, INV_GAMMA_PDF, UNIFORM_PDF
stderr E_EPS_C, GAMMA_PDF, 0.05, 0.03, 0, inf; //, 0.05; 
stderr E_EPS_ETA, GAMMA_PDF, 0.1, 0.06, 0, inf; //, 0.01;  
stderr E_EPS_ETAM, GAMMA_PDF, 0.02, 0.015, 0, inf; //, 0.01;  
stderr E_EPS_ETAX, GAMMA_PDF, 0.1, 0.06, 0, inf; //, 0.01;  
stderr E_EPS_EX, GAMMA_PDF, 0.005, 0.03, 0, inf; //, 0.01;  
stderr E_EPS_G, GAMMA_PDF, 0.05, 0.03, 0, inf; //, 0.01;  
stderr E_EPS_IG, GAMMA_PDF, 0.05, 0.03, 0, inf; //, 0.01;  
stderr E_EPS_L, GAMMA_PDF, 0.05, 0.03, 0, inf; //, 2; //, 0.01;  
stderr E_EPS_LOL, GAMMA_PDF, 0.005, 0.003, 0, inf; //, 2; //, 0.01;  
stderr E_EPS_M, GAMMA_PDF, 0.0025, 0.0015, 0, inf; //, 0.01;  
stderr E_EPS_RPREME, GAMMA_PDF, 0.005, 0.003, 0, inf; //, 0.01;  
stderr E_EPS_RPREMK, GAMMA_PDF, 0.005, 0.003, 0, inf; //, 0.01;  
stderr E_EPS_TR, GAMMA_PDF, 0.05, 0.03, 0, inf; //, 0.01;  
stderr E_EPS_W, GAMMA_PDF, 0.05, 0.03, 0, inf; //, 0.1;
stderr E_EPS_Y, GAMMA_PDF, 0.05, 0.03, 0, inf; //, 0.01;  
A2E, BETA_PDF, 0.05, 0.024, 0, 0.1; //, 5; //, 0.1;
G1E, BETA_PDF, 0, 0.6, -1.5, 1.5; //, 0.2;
GAMIE, GAMMA_PDF, 30, 20, 0, inf; //, 0.01;
GAMI2E, GAMMA_PDF, 15, 10, 0, inf; //, 2; //, 0.01;
GAMLE, GAMMA_PDF, 30, 20, 0, inf; //, 0.02;
GAMPE, GAMMA_PDF, 30, 20, 0, inf; //, 0.05;     
GAMPME, GAMMA_PDF, 30, 20, 0, inf; //, 0.05;     
GAMPXE, GAMMA_PDF, 30, 20, 0, inf; //, 0.05;     
GAMWE, GAMMA_PDF, 30, 20, 0, inf; //, 0.2;
GSLAG, BETA_PDF, 0, 0.4, -1, 1; //, 0.2;
GVECM, BETA_PDF, -0.5, 0.2, -1, 0; //, 0.2;
HABE, BETA_PDF, 0.7, 0.1, 0, 1; //, 0.2; 
HABLE, BETA_PDF, 0.7, 0.1, 0, 1; //, 0.2; 
IG1E, BETA_PDF, 0, 0.6, -1.5, 1.5; //, 0.2; 
IGSLAG, BETA_PDF, 0.5, 0.2, 0, 1; //, 0.2;
IGVECM, BETA_PDF, -0.5, 0.2, -1, 0; //, 0.2;
ILAGE, BETA_PDF, 0.85, 0.075, 0, 1; //, 0.5; 
KAPPAE, GAMMA_PDF, 1.25, 0.5, 0, inf; //, 1; //, 1;
RHOCE, BETA_PDF, 0.85, 0.075, 0, 1; //, 0.2;
RHOETA, BETA_PDF, 0.5, 0.2, 0, 1; //, 0.2;
RHOETAM, BETA_PDF, 0.85, 0.075, 0, 1; //, 0.2;  // as Smets Wouters
RHOETAX, BETA_PDF, 0.85, 0.075, 0, 1; //, 0.2;
RHOGE, BETA_PDF, 0.5, 0.2, 0, 1; //, 0.2;
RHOIG, BETA_PDF, 0.85, 0.075, 0, 1; //, 0.2;
RHOLE, BETA_PDF, 0.85, 0.075, 0, 1; //, 0.2;
RHOL0, BETA_PDF, 0.95, 0.02, 0, 1; //, 0.2;
RHOPCPM, BETA_PDF, 0.5, 0.2, 0, 1; //, 0.2;
RHOPWPX, BETA_PDF, 0.5, 0.2, 0, 1; //, 0.2;  // as Smets Wouters
RHORPE, BETA_PDF, 0.85, 0.075, 0, 1; //, 0.2;
RHORPK, BETA_PDF, 0.85, 0.075, 0, 1; //, 0.2;
RHOUCAP0, BETA_PDF, 0.95, 0.02, 0, 1; //, 0.2;
RPREME, BETA_PDF, 0.02, 0.008, 0, 0.04; //, 0.2;
RPREMK, BETA_PDF, 0.02, 0.008, 0, 0.04; //, 0.2;
SE, BETA_PDF, 0.8, 0.08, 0.6, 1; //, 5;
SFPE, BETA_PDF, 0.5, 0.2, 0, 1; //, 5;
SFPME, BETA_PDF, 0.5, 0.2, 0, 1; //, 5;
SFPXE, BETA_PDF, 0.5, 0.2, 0, 1; //, 5;
SFWE, BETA_PDF, 0.5, 0.2, 0, 1; //, 5;
SIGC, GAMMA_PDF, 2, 1, 0, inf; //, 1; //, 1;
SIGEXE, GAMMA_PDF, 1.25, 0.5, 0, inf; //, 1; //, 1;
SIGIME, GAMMA_PDF, 1.25, 0.5, 0, inf; //, 1; //, 1;
SLC, BETA_PDF, 0.5, 0.1, 0, 1; //, 5;
TINFE, BETA_PDF, 2, 0.4, 1, 3;
TR1E, BETA_PDF, 0, 0.6, -1.5, 1.5; //, 0.2;
RHOTR, BETA_PDF, 0.85, 0.075, 0, 1; //, 0.2;
TYE1, BETA_PDF, 0.3, 0.2, 0, 1.5;
TYE2, BETA_PDF, 0.3, 0.2, 0, 1.5;
WRLAG, BETA_PDF, 0.5, 0.2, 0, 1; //, 5;
end;



varobs E_LCY  E_LER  E_LGY  E_LIGSN  E_LISN  E_LL  E_GY  E_LYWR  E_INOM    
     E_PHI  E_LPMP  E_LPXP  E_TRW  E_INOMW  E_PHIW  E_LYWY  
     E_PHIPI; //E_WRPHI;
     
     

// for estimation starting 1991 and training from 1989, use:
// first_obs=45, presample=12, nobs=73;

// for estimation starting 1981 and training from 1978, use:
// first_obs=2, presample=11, nobs=116;

// load posterior mode estimation (point estimate)
estimation(datafile=ddd, first_obs=2, presample=11, mode_file = quest1_mode,
nobs=116, mode_compute=0, mh_replic=0, nograph, forecast=12, mh_drop=0.5, tex, filter_step_ahead=[1 4]); //, bayesian_irf, tex); //, filtered_vars, smoother);
oo_mode=oo_;

load quest1_results;

// load full posterior estimate
options_.filter_step_ahead=[]; 
estimation(datafile=ddd, first_obs=2, presample=11, nograph, mode_file = quest1_mean, load_mh_file, //mode_check, 
nobs=116, mode_compute=0, mh_replic=0, forecast=0, mh_drop=0.5, mh_jscale=0.22, mh_nblocks=2);

